;Sam Hardcastle
;LED Walker

		processor	PIC16F84
		include		<P16f84.inc>
		__config	_RC_OSC & _WDT_OFF & _PWRTE_OFF

		cblock	H'1A'			;Set position for variables
			VAR1				;
			VAR2				;
			VAR3				;
		endc					;

		bcf		STATUS,C		;Clears Status'
		bcf		STATUS,Z		;
		bcf		STATUS,DC		;

		tris	PORTB			;Sets PORTB for outputs
		
Left:	clrw					;ClearW
		movlw	B'00000001'		;Move 1 to W
		movwf	PORTB			;Move W to PORTB register

		movlw	B'00010000'		;Move 16 to W
		movwf	VAR1			;Move W to VAR!

loop:	
		movf	PORTB,W			;Move PortB to F
		xorwf	VAR1,W			;Combine with VAR1
		btfsc	STATUS,Z		;Check if Zero
		Call	Right			;Yes- goto right
		rlf		PORTB			;No- shift register to left
		Call	Wait
		goto	loop			;Continue Process

Right:	clrw					;Clear W
		movlw	B'00010000'		;Move 16 to W
		movwf	PORTB			;Move W to PORTB

		movlw	B'00000001'		;Move 1 to W
		movwf	VAR1			;Move W to VAR1

loop2:	movf	PORTB,W			;Move PORTB to F
		xorwf	VAR1,W			;Combine with VAR1
		btfsc	STATUS,Z		;Check if zero
		Call	Left			;Yes- goto left
		rrf		PORTB			;NO- Shift register to right
		Call	Wait
		goto	loop2			;continue process

Wait:	movlw		D'200'		;Put Deciaml 200 into W
		movwf		VAR2		;Move W to VAR2
loop4:	movwf		VAR3		;Move W to VAR3
		decfsz		VAR2,f		;Decrease VAR2 by 1 until zero
		goto		loop4		;Not zero? Goto loop4
		return					;Return

		end
